.586
.model flat,stdcall
option casemap:none

include CtrlPanel.inc
include m:\masm32\macros\macros.asm

.code

CPlApplet PROC	hwndCPL:DWORD, uMsg:DWORD, lParam1:DWORD, lParam2:DWORD
	
	mov		eax,uMsg
	.if eax==CPL_INIT	; first message, sent once 
		Invoke GetModuleHandle, CTEXT("CtrlPanel.cpl")
		.if eax != NULL
			mov hCpl, eax
			mov eax, TRUE
			ret
		.endif
		
	.elseif eax==CPL_GETCOUNT 	; second message, sent once 
		mov eax, 1
		ret
		
	.elseif eax==CPL_INQUIRE	; third message, sent once per application	
		push    esi
		mov     esi, lParam2
		assume  esi:ptr CPLINFO
		mov     [esi].lData, 0
		mov     [esi].idIcon, 101
		mov     [esi].idName, 201
		mov     [esi].idInfo, 202
		assume  esi: nothing
		pop     esi
		
	.elseif eax==CPL_DBLCLK		; application icon double-clicked	
		 
	.elseif eax==CPL_STOP		; sent once per application before CPL_EXIT	
		mov eax, 0
		
	.elseif eax==CPL_EXIT		; sent once before FreeLibrary is called 		
		mov eax, 1
		
	.endif
		
	ret

CPlApplet endp


CtrlPanelMain	PROC hWin:HWND,iMsg:DWORD,wParam:WPARAM, lParam:LPARAM
	
	mov  eax,iMsg
	.if eax==WM_INITDIALOG

	.elseif eax==WM_CLOSE
       	invoke EndDialog,hWin,NULL
	
	.elseif eax==WM_COMMAND
 		mov		eax,wParam
		and		eax,0FFFFh
		.if eax==IDC_EXIT
        	invoke SendMessage,hWin,WM_CLOSE,NULL,NULL
		.endif
	
	.else
      	mov eax,FALSE
		ret
	.endif
	
	mov  eax,TRUE
	ret	
	
	
	ret

CtrlPanelMain endp


End CPlApplet